# Dynamically Generated
@builtin "number.ne"
@builtin "string.ne"
@builtin "whitespace.ne"
@{%
    function compact(v) {
        if (Array.isArray(v)) {
            return v.reduce((a, v) => (v === null || v === undefined || (v && v.length === 0) ) ? a : (a.push(v), a), []);
        } else {
            return v;
        }
    }

    function flatten(v) {
        let r;
        if (Array.isArray(v)) {
            r = v.reduce((a,v) => (a.push(...((v && Array.isArray(v)) ? flatten(v) : [v])), a), []);
        } else {
            r = v;
        }
        r = compact(r);
        return r;
        }
%}


rule -> rule0 rule1 rule2 rule3 rule4 rule5 rule6 rule7 rule8 rule9 rule10 rule11 rule12 rule13 rule14 rule15 rule16 rule17 rule18 rule19 rule20 rule21 rule22 rule23 rule24 rule25 rule26 rule27 rule28 rule29 rule30 rule31 rule32 rule33 rule34 
{% ([ rule0,rule1,rule2,rule3,rule4,rule5,rule6,rule7,rule8,rule9,rule10,rule11,rule12,rule13,rule14,rule15,rule16,rule17,rule18,rule19,rule20,rule21,rule22,rule23,rule24,rule25,rule26,rule27,rule28,rule29,rule30,rule31,rule32,rule33,rule34 ]) => {
    return {
        $class: "org.accordproject.perishablegoods.contract.TemplateModel",
        
        grower : rule5,
        importer : rule3,
        shipment : rule1,
        dueDate : rule23,
        unitPrice : rule7,
        unit : rule9,
        minUnits : rule11,
        maxUnits : rule13,
        product : rule17,
        sensorReadingFrequency : rule19,
        duration : rule21,
        minTemperature : rule25,
        maxTemperature : rule27,
        minHumidity : rule29,
        maxHumidity : rule31,
        penaltyFactor : rule33
    };
}
%}

ROOT -> rule0 
{% ([ rule0 ]) => {
    return {
        
        
    };
}
%}



rule0 -> "On receipt of the shipment " 


rule1 -> String {% id %} # shipment 


rule2 -> " the importer " 


rule3 -> String {% id %} # importer 


rule4 -> " pays the grower " 


rule5 -> String {% id %} # grower 


rule6 -> " " 


rule7 -> Double {% id %} # unitPrice 


rule8 -> " USD per " 


rule9 -> Unit {% id %} # unit 


rule10 -> ". The shipment must contain between " 


rule11 -> Integer {% id %} # minUnits 


rule12 -> " and " 


rule13 -> Integer {% id %} # maxUnits 


rule14 -> " " 


rule15 -> Unit {% id %} # unit 


rule16 -> " of " 


rule17 -> String {% id %} # product 


rule18 -> ".\n\nShipping containers used must be temperature and humidity controlled, and sensor readings must be logged at least " 


rule19 -> Integer {% id %} # sensorReadingFrequency 


rule20 -> " per " 


rule21 -> Duration {% id %} # duration 


rule22 -> ".\n\nShipments that arrive after " 


rule23 -> DateTime {% id %} # dueDate 


rule24 -> " are to be considered spoiled and must be arranged to be returned to or disposed of by grower at cost to grower.\n\nTemperature readings for the shipment must be between " 


rule25 -> Double {% id %} # minTemperature 


rule26 -> " and " 


rule27 -> Double {% id %} # maxTemperature 


rule28 -> ".\n\nHumidity readings for the shipment must be between " 


rule29 -> Double {% id %} # minHumidity 


rule30 -> " and " 


rule31 -> Double {% id %} # maxHumidity 


rule32 -> ".\n\nShipments that have a temperature or humidity reading outside the agreed range have a price penalty applied calculated using the Formula for Breach Penalty Calculation below. The breach penalty factor to be used is " 


rule33 -> Double {% id %} # penaltyFactor 


rule34 -> ".\n\nFormula for Breach Penalty Calculation:\n   penalty = number of shipment units x difference between sensor reading and agreed range x breach penalty factor\n" 


ContractState -> String  __  String 

{% ( data ) => {
    return {
        $class: "org.accordproject.common.ContractState",
        stateId : data[0],
        contract : data[2]
    };
}
%}


ContractModel -> String 

{% ( data ) => {
    return {
        $class: "org.accordproject.common.ContractModel",
        contractId : data[0]
    };
}
%}


ClauseModel -> String 

{% ( data ) => {
    return {
        $class: "org.accordproject.common.ClauseModel",
        clauseId : data[0]
    };
}
%}


Request -> String  __  DateTime 

{% ( data ) => {
    return {
        $class: "org.accordproject.common.Request",
        transactionId : data[0],
        timestamp : data[2]
    };
}
%}


Response -> String  __  DateTime 

{% ( data ) => {
    return {
        $class: "org.accordproject.common.Response",
        transactionId : data[0],
        timestamp : data[2]
    };
}
%}


ErrorResponse -> String  __  DateTime 

{% ( data ) => {
    return {
        $class: "org.accordproject.common.ErrorResponse",
        transactionId : data[0],
        timestamp : data[2]
    };
}
%}


Payload -> ContractModel  __  Request  __  ContractState 

{% ( data ) => {
    return {
        $class: "org.accordproject.common.Payload",
        contract : data[0],
        request : data[2],
        state : data[4]
    };
}
%}


Success -> Response  __  ContractState  __  Event:+ 

{% ( data ) => {
    return {
        $class: "org.accordproject.common.Success",
        response : data[0],
        state : data[2],
        emit : data[4]
    };
}
%}


Failure -> ErrorResponse 

{% ( data ) => {
    return {
        $class: "org.accordproject.common.Failure",
        error : data[0]
    };
}
%}


ShipmentStatus -> "CREATED" {% id %} | "IN_TRANSIT" {% id %} | "ARRIVED" {% id %} 


Unit -> "KG" {% id %} | "BUSHEL" {% id %} | "TONNE" {% id %} | "BARREL" {% id %} | "CORD" {% id %} 


Duration -> "WEEK" {% id %} | "HOUR" {% id %} | "DAY" {% id %} | "MONTH" {% id %} | "YEAR" {% id %} | "MINUTE" {% id %} 


SensorReading -> Double  __  Double  __  String  __  String  __  DateTime 

{% ( data ) => {
    return {
        $class: "org.accordproject.perishablegoods.SensorReading",
        centigrade : data[0],
        humidity : data[2],
        shipment : data[4],
        transactionId : data[6],
        timestamp : data[8]
    };
}
%}


ShipmentReceived -> Integer  __  String  __  String  __  DateTime 

{% ( data ) => {
    return {
        $class: "org.accordproject.perishablegoods.ShipmentReceived",
        unitCount : data[0],
        shipment : data[2],
        transactionId : data[4],
        timestamp : data[6]
    };
}
%}


PriceCalculation -> Double  __  Double  __  Boolean  __  String  __  String  __  DateTime 

{% ( data ) => {
    return {
        $class: "org.accordproject.perishablegoods.PriceCalculation",
        totalPrice : data[0],
        penalty : data[2],
        late : data[4],
        shipment : data[6],
        transactionId : data[8],
        timestamp : data[10]
    };
}
%}


Shipment -> String  __  ShipmentStatus  __  String  __  String  __  SensorReading:*  __  String 

{% ( data ) => {
    return {
        $class: "org.accordproject.perishablegoods.Shipment",
        shipmentId : data[0],
        status : data[2],
        grower : data[4],
        importer : data[6],
        sensorReadings : data[8],
        smartClause : data[10]
    };
}
%}


Address -> String:?  __  String  __  String:?  __  String:? 

{% ( data ) => {
    return {
        $class: "org.accordproject.perishablegoods.Address",
        city : data[0],
        country : data[2],
        street : data[4],
        zip : data[6]
    };
}
%}


Grower -> String  __  Address  __  Double 

{% ( data ) => {
    return {
        $class: "org.accordproject.perishablegoods.Grower",
        email : data[0],
        address : data[2],
        accountBalance : data[4]
    };
}
%}


Shipper -> String  __  Address  __  Double 

{% ( data ) => {
    return {
        $class: "org.accordproject.perishablegoods.Shipper",
        email : data[0],
        address : data[2],
        accountBalance : data[4]
    };
}
%}


Importer -> String  __  Address  __  Double 

{% ( data ) => {
    return {
        $class: "org.accordproject.perishablegoods.Importer",
        email : data[0],
        address : data[2],
        accountBalance : data[4]
    };
}
%}


SetupDemo -> String  __  DateTime 

{% ( data ) => {
    return {
        $class: "org.accordproject.perishablegoods.SetupDemo",
        transactionId : data[0],
        timestamp : data[2]
    };
}
%}



# Basic types
NUMBER -> [0-9] 
{% (d) => {return parseInt(d[0]);}%}

DOUBLE_NUMBER -> NUMBER NUMBER
{% (d) => {return '' + d[0] + d[1]}%}

MONTH -> DOUBLE_NUMBER
DAY -> DOUBLE_NUMBER
YEAR -> DOUBLE_NUMBER DOUBLE_NUMBER
{% (d) => {return '' + d[0] + d[1]}%}

DATE -> MONTH "/" DAY "/" YEAR
{% (d) => {return '' + d[4] + '-' + d[0] + '-' + d[2]}%}

Word -> [\S]:*
{% (d) => {return d[0].join('');}%}

BRACKET_PHRASE -> "[" Word (__ Word):* "]" {% ((d) => {return d[1] + ' ' + flatten(d[2]).join(" ");}) %}

String -> dqstring {% id %}
Double -> decimal {% id %}
Integer -> int {% id %}
Long -> int {% id %}
Boolean -> "true" {% id %} | "false" {% id %}
DateTime -> DATE  {% id %}